#include <stdio.h> 
#include <string.h>
#include <stdlib.h>
#ifdef WIN32
#include <windows.h>
#else
#define strnicmp strncasecmp
#endif


#define _MAXFI 64
#define _MAXLI 1024

/*
JOIN 1.01 -- June 30, 2004.

Copyright 2003, Norm London, London Computing.
norm_london@londoncomputing.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

// JoinS up to _Maxfi files to stdout; each file can have a maximum record size of _maxli

int main(int argc,char *argv[]) {

	FILE *fi[_MAXFI];
	char buf[_MAXFI][_MAXLI], delimstr[16];
	char eof[_MAXFI], noteof = 9;
	
	int i;
	int start = 0;
	
	
		FILE *hlp;
#ifdef WIN32
	char tmp[_MAX_PATH],*p,cmd[_MAX_PATH];

	if ((p=getenv("tmp")) == NULL)
		if ((p = getenv("temp")) == NULL)
			GetWindowsDirectory(tmp,_MAX_PATH);
		else
			strcpy(tmp,p);
	else
		strcpy(tmp,p);
	if (tmp[strlen(tmp)-1] != '\\')
		strcat(tmp,"\\");

	strcat(tmp,"ljoin.hlp");
	hlp = fopen(tmp,"w");
#else
	hlp = stderr;
#endif

	noteof = 0;
	if (argc < 3) {
		fprintf(hlp,"JOIN 1.01     %s\n",__DATE__);
		fprintf(hlp,"Copyright 2004, Norm London, London Computing.\n");
		fprintf(hlp,"norm_london@londoncomputing.com\n");
		fprintf(hlp,"\n");
		fprintf(hlp,"This program is free software; you can redistribute it and/or modify\n");
		fprintf(hlp,"it under the terms of the GNU General Public License as published by\n");
		fprintf(hlp,"the Free Software Foundation; either version 2 of the License, or\n");
		fprintf(hlp,"at your option) any later version.\n");
		fprintf(hlp,"\n");
		fprintf(hlp,"This program is distributed in the hope that it will be useful,\n");
		fprintf(hlp,"but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
		fprintf(hlp,"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
		fprintf(hlp,"GNU General Public License for more details.\n");
		fprintf(hlp,"\n");
		fprintf(hlp,"You should have received a copy of the GNU General Public License\n");
		fprintf(hlp,"along with this program; if not, write to the Free Software\n");
		fprintf(hlp,"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
		fprintf(hlp,"\n");
		fprintf(hlp,"Usage is: Join [-d=delimstr ] File1 File2 [File3... ]\n\n");
		fprintf(hlp,"ljoin contatenates text from each of the files into\n");
		fprintf(hlp,"a single line that is written to STDOUT.  It reads one\n");
		fprintf(hlp,"a line from each of the input files and writes a single\n");
		fprintf(hlp,"line to output.  The files should each have the same number\n");
		fprintf(hlp,"of lines.\n\n");
		fprintf(hlp,"You may list up to %d files to be joined.\n",_MAXFI);
		fprintf(hlp,"The maximum record size for each file must be < %d\n\n",_MAXLI);
		fprintf(hlp,"if present, delimstr is used to seperate inputs from the various files.\n");
		fprintf(hlp,"delimstr may be any 1-15 printable characters.\n\n");
		fprintf(hlp,"Creates output on stdout.  Output Line i\n"); 
		fprintf(hlp,"consists of Line i of files 1... concatenated.\n");
		#ifdef WIN32
		fclose(hlp);
		strcpy(cmd,"NOTEPAD.EXE ");
		strcat(cmd,tmp);

		WinExec(cmd,SW_SHOW);
#endif
		return(8);
	}

	// Look for delimstr
	if (strnicmp(argv[1],"-d=",3) == 0) {
		start = 1;
		strcpy(delimstr,argv[1]+3);
	}
	else
		*delimstr = 0;

	for (i=1;i < argc;++i) {
		fi[i] = NULL;
		eof[i] = 0;
		if (i < argc)
			fi[i] = fopen(argv[i+start],"r");                             
		if (fi[i] != NULL)
			++noteof;
	}                
		
	while (noteof) {                                                       
		for (i = 1; i < 10 && i < argc; ++ i) { 
			if (fi[i] == NULL || eof[i])
				continue;
				
			if (fgets(buf[i],255,fi[i]) == NULL) {
				// End of file, set indicator, decrement count of open files */
				eof[i] = 1;                       
				--noteof;
				buf[i][0] = 0; 
				fclose(fi[i]);
			}
			else {
				buf[i][strlen(buf[i]) - 1] = 0;  /* remove trailing newline char */
				if (i > 1 && *delimstr)
					fputs(delimstr,stdout);
				fputs(buf[i],stdout);
			}
		}
		putchar('\n');                         
		
	}         
	return(0);
}       
	
	
		
		
		
					
		
			
